<script context="module">
	import { ensureAuthenticated } from "../_auth.js"
	export function preload(page, session) {
		ensureAuthenticated.call(this, page, session)
	}
</script>

<script>
	import { goto } from "@sapper/app"

	export let submitErrorMessage = null
	export let name = null
	export let resources = []

	export function addResource(file) {
		name = file.name
		resources.push(file)
	}

	export function deleteResource(name) {
		resources = resources.filter(resource => resource.name !== name)
	}

	export async function submit() {
		// Build FormData instance from component properties.
		const formData = new FormData()
		formData.append("name", name)
		resources.forEach(resource => {
			formData.append(resource.name, resource)
		})

		const response = await fetch("/api/data-packages/new", {
			method: "POST",
			body: formData
		})
		const data = await response.json()
		if (!response.ok) {
			submitErrorMessage = data.err
			return
		}

		goto(`/data-packages/${data.project.name}`)
	}

	function handleInputFileChange(event) {
		const { files } = event.target
		if (!files || files.length === 0) {
			return
		}
		const file = files[0]
		addResource(file)
	}
</script>

<h1>New data package</h1>

<form on:submit|preventDefault={submit}>
	{#if name !== null}
		<p>
			<label>
				Name
				<input name="name" type="text" bind:value={name} />
			</label>
		</p>
	{/if}
	<p>
		<input name="resource" type="file" on:change={handleInputFileChange} />
	</p>
	{#if resources.length > 0}
		<ul>
			{#each resources as { name }}
				<li>
					 {name}
					<button on:click={() => deleteResource(name)}>delete</button>
				</li>
			{/each}
		</ul>
	{/if}
	<p>
		<button disabled={!name || resources.length === 0} type="submit">Create</button>
	</p>
</form>

<!-- Once created, redirect to datapackage list page with a success message -->

<!-- Note: Add a datapackage View page -->

<!-- Note: Add a datapackage Edit page -->
